# NOTE: Derived from blib/lib/ClearCase/Wrapper.pm.
# Changes made here will be lost when autosplit is run again.
# See AutoSplit.pm.
package ClearCase::Wrapper;

#line 795 "blib/lib/ClearCase/Wrapper.pm (autosplit into blib/lib/auto/ClearCase/Wrapper/diffcr.al)"
sub diffcr {
    my %opt;
    GetOptions(\%opt, qw(data)) if grep m%^-d%, @ARGV;
    # If -data not passed, fall through to regular behavior.
    if ($opt{data}) {
	GetOptions(\%opt, qw(long));
	die Msg('E', "incompatible flags: -data and -long")
	    if exists $opt{long};

	require Digest::MD5;
	my $md51 = Digest::MD5->new;
	my $md52 = Digest::MD5->new;

	my $diffcr = ClearCase::Argv->new(@ARGV);
	my @results = $diffcr->qx;
	my %elems;
	for (@results) {
	    if (m%^([<>]\s+)(.*)@@([/\\]\S*)(.*)%) {
		my($prefix, $elem, $version, $suffix) = ($1, $2, $3, $4);
		next if ! -f $elem;
		if (exists $elems{$elem}) {
		    my $same = 0;
		    if ($elems{$elem}->[0] eq $version) {
			$same = 1;
		    } else {
			my $v1 = join('@@', $elem, $elems{$elem}->[0]);
			my $v2 = join('@@', $elem, $version);

			if (open(V1, $v1) && open(V2, $v2)) {
			    $md51->addfile(*V1);
			    close(V1);
			    my $digest1 = $md51->hexdigest;

			    $md52->addfile(*V2);
			    close(V2);
			    my $digest2 = $md52->hexdigest;

			    if ($digest1 eq $digest2) {
				$same = 1;
			    } else {
				chomp $elems{$elem}->[1];
				$elems{$elem}->[1] .= " [$digest1]\n";
				chomp $_;
				$_ .= " [$digest2]\n";
			    }
			}
		    }
		    if (!$same) {
			print $elems{$elem}->[1];
			print;
		    }
		    delete $elems{$elem};
		} else {
		    $elems{$elem} = [$version, $_];
		}
	    } else {
		print;
	    }
	}
	exit(0);
    }
}

# end of ClearCase::Wrapper::diffcr
1;
