# NOTE: Derived from blib/lib/ClearCase/Wrapper.pm.
# Changes made here will be lost when autosplit is run again.
# See AutoSplit.pm.
package ClearCase::Wrapper;

#line 965 "blib/lib/ClearCase/Wrapper.pm (autosplit into blib/lib/auto/ClearCase/Wrapper/lsprivate.al)"
sub lsprivate {
    my %opt;
    GetOptions(\%opt, qw(directory recurse all avobs eclipsed
						ext relative type=s visible));

    my $lsp = ClearCase::Argv->new(@ARGV);
    $lsp->parse(qw(short co|do|other|long tag=s invob=s));

    my $pname = '.';

    # Extension: allow [dir] argument
    if ($lsp->args) {
	chomp(($pname) = $lsp->args);
	$lsp->args;
	# Default to -rec but accept -dir.
	$opt{recurse} = 1 unless $opt{directory} || $opt{all} || $opt{avobs};
    }

    # Extension: implement [-dir|-rec|-all|-avobs]
    if ($opt{directory} || $opt{recurse} || $opt{all} || $opt{ext}) {
	require Cwd;
	my $dir = Cwd::abs_path($pname);
	my $tag = $lsp->flag('tag');
	$lsp->opts($lsp->opts, '-invob', $pname)
			if ($opt{directory} || $opt{recurse} || $opt{all}) &&
			    !$lsp->flag('invob');
	if ($opt{directory} || $opt{recurse}) {
	    if ($dir =~ s%/+view/([^/]+)%%) {	# UNIX view-extended path
		$tag ||= $1;
	    } elsif ($dir =~ s%^[A-Z]:%%) {	# WIN view-extended path
		if ($tag) {
		    $dir =~ s%^/$tag%%i;
		} else {
		    $tag = ViewTag(@ARGV);
		}
	    } elsif (!$tag) {
		$tag = ViewTag(@ARGV);
	    }
	    $lsp->opts($lsp->opts, '-tag', $tag) if !$lsp->flag('tag');
	}
	chomp(my @privs = sort $lsp->qx);
	exit $? if $? || !@privs;
	# Strip out all results which are not eclipsed. An element
	# is eclipsed if (a) there's a view-private copy,
	# (b) there's also a versioned copy, and (c) it's not checked out.
	if ($opt{eclipsed}) {
	    my %coed = ();
	    if ($lsp->flag('short')) {
		%coed = map {chomp; $_ => 1}
				ClearCase::Argv->lsco(qw(-avo -s -cvi))->qx;
	    }
	    my @t_privs;
	    for (@privs) {
		next if m%\s\[checkedout\]%;
		next unless -e "$_@@/main/0";
		my $sv = $_;
		$sv =~ s%(/+view)?/$tag%% if $tag;
		next if exists $coed{$sv};
		push(@t_privs, $_);
	    }
	    @privs = @t_privs;
	}
	if ($opt{directory} || $opt{recurse}) {
	    for (@privs) {
		if (MSWIN) {
		    s/^[A-Z]://i;
		    s%\\%/%g;
		}
		s%(/+view)?/$tag%%;
	    }
	    @privs = map {$_ eq $dir ? "$_/" : $_} @privs;
	    my $job = $opt{relative} ? 'map ' : 'grep ';
	    $job .= $opt{recurse} ? '{m%^$dir/(.*)%}' : '{m%^$dir/([^/]*)$%s}';
	    $opt{type} ||= 'e' if $opt{visible};
	    $job = "grep {-$opt{type}} $job" if $opt{type};
	    eval qq(\@privs = $job \@privs);
	    exit 0 if !@privs;
	}
	if ($opt{ext}) {	# sort by extension
	    require File::Basename;
	    @privs = map  { $_->[0] }
	       sort { "$a->[1]$a->[2]$a->[3]" cmp "$b->[1]$b->[2]$b->[3]" }
	       map  { [$_, (File::Basename::fileparse($_, '\.\w+'))[2,0,1]] }
	       @privs;
	}
	for (@privs) { print $_, "\n" }
	exit 0;
    }
    $lsp->exec;
}

# end of ClearCase::Wrapper::lsprivate
1;
